import cv2 as cv
import numpy as np
import tkinter as tk
from tkinter import filedialog, messagebox
import os
from PIL import Image, ImageTk
import configparser
class ImageIO:
    def __init__(self, shared_data):
        self.shared_data = shared_data

    def load_image(self, path):
        return cv.imread(path, cv.IMREAD_COLOR)

    def write_image(self, img, fileName="image.png"):
        if cv.imwrite(fileName, img):
            print(f"File {fileName} Written Successfully")
        else:
            print("File writing failed")

    def show_image(self, img, title="Image Title", canvas=None):
        img_rgb = cv.cvtColor(img, cv.COLOR_BGR2RGB)
        img_pil = Image.fromarray(img_rgb)
        img_tk = ImageTk.PhotoImage(img_pil)
        
        canvas.update_idletasks()  # Force the canvas to update its dimensions
        canvas_width = canvas.winfo_width()  # Get the updated canvas width
        
        if self.shared_data.isLeft:
            # Align image to the top-right corner
            canvas.create_image(canvas_width, 0, anchor=tk.NE, image=img_tk)
        else:
            # Align image to the top-left corner
            canvas.create_image(0, 0, anchor=tk.NW, image=img_tk)
        
        canvas.image = img_tk  # Prevent image from being garbage collected

